-- phpMyAdmin SQL Dump
-- version 4.5.1
-- http://www.phpmyadmin.net
--
-- Host: 127.0.0.1
-- Generation Time: Nov 06, 2016 at 12:29 PM
-- Server version: 10.1.13-MariaDB
-- PHP Version: 5.6.23

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `metalims_demo`
--

-- --------------------------------------------------------

CREATE DATABASE `metalims_demo`;

CREATE USER 'metalims_test'@'localhost' IDENTIFIED BY 'metalims_password123';

GRANT INSERT ON metalims_demo.* TO 'metalims_test'@'localhost';

GRANT SELECT ON metalims_demo.* TO 'metalims_test'@'localhost';

GRANT UPDATE ON metalims_demo.* TO 'metalims_test'@'localhost';

GRANT DELETE ON metalims_demo.* TO 'metalims_test'@'localhost';

FLUSH PRIVILEGES;

USE `metalims_demo`;


--
-- Table structure for table `analysis`
--

CREATE TABLE `analysis` (
  `analysis_name` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `analysis`
--

INSERT INTO `analysis` (`analysis_name`, `visible`) VALUES
('MEGAN Analysis - Metagenome', 1),
('MEGAN Analysis - Metagenome (update db 2016/5)', 1);

-- --------------------------------------------------------

--
-- Table structure for table `application`
--

CREATE TABLE `application` (
  `application` varchar(30) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1',
  `application_abbrev` varchar(10) COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `application`
--

INSERT INTO `application` (`application`, `visible`, `application_abbrev`) VALUES
('Amplicon sequencing', 1, 'A' ),
('ChIP-sequencing', 1, 'C'),
('Exome sequencing', 1, 'E'),
('Metagenome PacBio', 1, 'MP'),
('Metagenome sequencing', 1, 'M'),
('Metatranscriptome sequencing', 1, 'MT'),
('PacBio Isolates', 1, 'P'),
('Small RNA sequencing', 1, 'S'),
('Transcriptome Sequencing', 1, 'T'),
('Whole genome sequencing', 1, 'W');

-- --------------------------------------------------------

--
-- Table structure for table `container_type`
--

CREATE TABLE `container_type` (
  `container_type` varchar(15) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `container_type`
--

INSERT INTO `container_type` (`container_type`, `visible`) VALUES
('384 well plate', 1),
('96 well plate', 1),
('Tube', 1);

-- --------------------------------------------------------

--
-- Table structure for table `create_user_things`
--

CREATE TABLE `create_user_things` (
  `thing_id` int(11) NOT NULL,
  `label_name` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `type` varchar(15) COLLATE utf8_unicode_ci NOT NULL,
  `select_values` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `visible` tinyint(4) NOT NULL DEFAULT '1',
  `required` varchar(1) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'N'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `create_user_things`
--

INSERT INTO `create_user_things` (`thing_id`, `label_name`, `type`, `select_values`, `visible`, `required`) VALUES
(1, 'Temperature (c)', 'numeric_input', '', 1, 'N'),
(2, 'Salinity (ppt)', 'numeric_input', NULL, 1, 'N'),
(3, 'Depth (m)', 'numeric_input', NULL, 1, 'N');

-- --------------------------------------------------------

--
-- Table structure for table `daily_data2`
--

CREATE TABLE `daily_data2` (
  `daily_date` date NOT NULL,
  `location` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `notes` mediumtext COLLATE utf8_unicode_ci DEFAULT NULL,
  `entered_by` varchar(30) COLLATE utf8_unicode_ci NOT NULL,
  `updated_by` varchar(30) COLLATE utf8_unicode_ci DEFAULT NULL,
  `update_timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `orig_time_stamp` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `daily_data2`
--

INSERT INTO `daily_data2` (`daily_date`, `location`, `notes`, `entered_by`, `updated_by`, `update_timestamp`, `orig_time_stamp`) VALUES
('2016-05-23', 'Office', '', 'Admin', NULL, '2016-05-24 06:16:46', '2016-09-19 07:13:48');

-- --------------------------------------------------------

--
-- Table structure for table `daily_data2_particle_counter`
--

CREATE TABLE `daily_data2_particle_counter` (
  `daily_date` date NOT NULL,
  `part_sens_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `location` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `start_time` time NOT NULL,
  `end_time` time NOT NULL,
  `avg_measurement` decimal(6,2) NOT NULL,
  `record_source` varchar(150) COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `daily_data2_particle_counter`
--

INSERT INTO `daily_data2_particle_counter` (`daily_date`, `part_sens_name`, `location`, `start_time`, `end_time`, `avg_measurement`, `record_source`) VALUES
('2016-05-23', 'LabData Velocicalc', 'Office', '07:00:00', '18:00:00', '6.00', 'Rotronics CO2 Meter 1');

-- --------------------------------------------------------

--
-- Table structure for table `dna_extraction`
--

CREATE TABLE `dna_extraction` (
  `d_kit_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `dna_extraction`
--

INSERT INTO `dna_extraction` (`d_kit_name`, `visible`) VALUES
('MoBio Power Soil Kit', 1),
('MoBio Power Water Kit', 1),
('Qiagen DNeasy Kity', 1);

-- --------------------------------------------------------

--
-- Table structure for table `drawer`
--

CREATE TABLE `drawer` (
  `drawer_id` varchar(40) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `drawer`
--

INSERT INTO `drawer` (`drawer_id`, `visible`) VALUES
('Alice', 1),
('Dan', 1),
('F1', 1),
('F2', 1),
('Used', 1);

-- --------------------------------------------------------

--
-- Table structure for table `freezer`
--

CREATE TABLE `freezer` (
  `freezer_id` varchar(30) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `freezer`
--

INSERT INTO `freezer` (`freezer_id`, `visible`) VALUES
('-80C', 1),
('20C', 1),
('Used', 1);

-- --------------------------------------------------------

--
-- Table structure for table `freezer_drawer`
--

CREATE TABLE `freezer_drawer` (
  `freezer_id` varchar(30) COLLATE utf8_unicode_ci NOT NULL,
  `drawer_id` varchar(40) COLLATE utf8_unicode_ci NOT NULL,
  `visible_flag` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `freezer_drawer`
--

INSERT INTO `freezer_drawer` (`freezer_id`, `drawer_id`, `visible_flag`) VALUES
('-80C', 'F1', 1),
('-80C', 'F2', 1),
('20C', 'Alice', 1),
('20C', 'Dan', 1),
('Used', 'Used', 1);

-- --------------------------------------------------------

--
-- Table structure for table `library_prep_kit`
--

CREATE TABLE `library_prep_kit` (
  `lib_prep_kit` varchar(40) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `library_prep_kit`
--

INSERT INTO `library_prep_kit` (`lib_prep_kit`, `visible`) VALUES
('Low Input Library Prep Kit', 1),
('Nextera DNA Library Preparation Kit', 1);

-- --------------------------------------------------------

--
-- Table structure for table `location`
--

CREATE TABLE `location` (
  `loc_name` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `address` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `loc_type` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `environmental_type` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `latitude` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `longitude` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `location`
--

INSERT INTO `location` (`loc_name`, `address`, `loc_type`, `environmental_type`, `latitude`, `longitude`, `visible`) VALUES
('(pooled)', '', '', '', '', '', 1),
('Beach', '987 Beach St', 'Rural', 'Open', '1.243402', '103.832800', 1),
('Office', '1234 Office Blvd', 'Residential', 'Closed', '1.348432', '103.683455', 1),
('Pond', '123 Lakeview road ', 'Outside', 'Open', '1.344313', '103.821471', 1);

-- --------------------------------------------------------

--
-- Table structure for table `media_type`
--

CREATE TABLE `media_type` (
  `media_type` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `media_type`
--

INSERT INTO `media_type` (`media_type`, `visible`) VALUES
('(pooled)', 1),
('Eswab', 1),
('Life Guard', 1),
('MEA', 1),
('MilliQ', 1),
('N/A', 1),
('TSA', 1);

-- --------------------------------------------------------

--
-- Table structure for table `number_of_seq_submissions`
--

CREATE TABLE `number_of_seq_submissions` (
  `sample_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `A` int(3) NOT NULL DEFAULT '0',
  `C` int(3) NOT NULL DEFAULT '0',
  `E` int(3) NOT NULL DEFAULT '0',
  `MP` int(3) DEFAULT '0',
  `M` int(3) NOT NULL DEFAULT '0',
  `MT` int(3) NOT NULL DEFAULT '0',
  `S` int(3) NOT NULL DEFAULT '0',
  `T` int(3) NOT NULL DEFAULT '0',
  `G` int(3) NOT NULL DEFAULT '0',
  `P` int(3) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `number_of_seq_submissions`
--

INSERT INTO `number_of_seq_submissions` (`sample_name`, `A`, `C`, `E`, `MP`, `M`, `MT`, `S`, `T`, `G`, `P`) VALUES
('2016/05/23first-projectA001', 0, 0, 0, 0, 2, 0, 0, 0, 0, 0),
('2016/05/23first-projectB004', 0, 0, 0, 0, 2, 0, 0, 0, 0, 0),
('2016/05/24first-projectA002', 0, 0, 0, 0, 2, 0, 0, 0, 0, 0),
('2016/05/24first-projectB003', 0, 0, 0, 0, 2, 0, 0, 0, 0, 0),
('2016/06/21second-projectB002', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
('2016/06/21second-projectB004', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
('2016/06/21second-projectB006', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
('2016/06/21second-projectW001', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
('2016/06/21second-projectW003', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
('2016/06/21second-projectW005', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
('2016/09/01first-projectS005', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);

-- --------------------------------------------------------

--
-- Table structure for table `particle_counter`
--

CREATE TABLE `particle_counter` (
  `part_sens_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `sensor_type` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `serial_num` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `particle_counter`
--

INSERT INTO `particle_counter` (`part_sens_name`, `sensor_type`, `serial_num`, `visible`) VALUES
('LabData Velocicalc', 'Wind Speed, Temperature, Humidity', '1', 1),
('OPC', 'Optical Particle Counter', '1', 1),
('Rotronics CO2 Monitor', 'CO2 Monitor', '1', 1);

-- --------------------------------------------------------

--
-- Table structure for table `pooled_sample_lookup`
--

CREATE TABLE `pooled_sample_lookup` (
  `new_pooled_samp_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `orig_sample_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `date_entered` date NOT NULL,
  `entered_by` varchar(150) COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `project_name`
--

CREATE TABLE `project_name` (
  `project_name` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `added_by` varchar(30) COLLATE utf8_unicode_ci NOT NULL,
  `description` mediumtext COLLATE utf8_unicode_ci NOT NULL,
  `seq_id_start` varchar(6) COLLATE utf8_unicode_ci NOT NULL,
  `time_stamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `project_name`
--

INSERT INTO `project_name` (`project_name`, `added_by`, `description`, `seq_id_start`, `time_stamp`, `visible`) VALUES
('first-project', 'Admin', 'First project for demo', 'FSTPJ', '2016-05-23 03:06:31', 1),
('second-project', 'Admin', 'Second project for demo', 'SCNPJ', '2016-05-23 03:46:25', 1);

-- --------------------------------------------------------

--
-- Table structure for table `quantitation_method`
--

CREATE TABLE `quantitation_method` (
  `quant_method` varchar(10) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `quantitation_method`
--

INSERT INTO `quantitation_method` (`quant_method`, `visible`) VALUES
('Picogreen', 1),
('Qubit DNA', 1),
('Qubit RNA', 1),
('Ribogreen', 1);

-- --------------------------------------------------------

--
-- Table structure for table `quant_instruments`
--

CREATE TABLE `quant_instruments` (
  `kit_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `quant_instruments`
--

INSERT INTO `quant_instruments` (`kit_name`, `visible`) VALUES
('PicoGreen', 1),
('Qubit', 1);

-- --------------------------------------------------------

--
-- Table structure for table `read_length`
--

CREATE TABLE `read_length` (
  `read_length` varchar(20) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `read_length`
--

INSERT INTO `read_length` (`read_length`, `visible`) VALUES
('100bp (HiSeq)', 1),
('150bp (HiSeq)', 1),
('150bp (MiSeq)', 1),
('250bp (HiSeq)', 1),
('300bp (MiSeq)', 1),
('50bp (HiSeq)', 1),
('50bp (MiSeq)', 1),
('75bp (HiSeq)', 1),
('75bp (MiSeq)', 1);

-- --------------------------------------------------------

--
-- Table structure for table `read_submission`
--

CREATE TABLE `read_submission` (
  `sample_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `subm_id` varchar(15) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `subm_db` varchar(15) COLLATE utf8_unicode_ci DEFAULT NULL,
  `subm_date` date DEFAULT NULL,
  `submitter` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `type_exp` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `time_stamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `read_submission`
--

INSERT INTO `read_submission` (`sample_name`, `subm_id`, `subm_db`, `subm_date`, `submitter`, `type_exp`, `time_stamp`, `visible`) VALUES
('2016/05/23first-projectA001', 'test1', 'DDBJ', '2016-09-01', 'Ann', 'Human sample', '2016-09-18 16:23:12', 1);

-- --------------------------------------------------------

--
-- Table structure for table `read_subm_database`
--

CREATE TABLE `read_subm_database` (
  `database_name` varchar(15) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `read_subm_database`
--

INSERT INTO `read_subm_database` (`database_name`, `visible`) VALUES
('DDBJ', 1),
('ENA', 1),
('GenBank', 1);

-- --------------------------------------------------------

--
-- Table structure for table `read_subm_exp_types`
--

CREATE TABLE `read_subm_exp_types` (
  `exp_types` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `read_subm_exp_types`
--

INSERT INTO `read_subm_exp_types` (`exp_types`, `visible`) VALUES
('Eukaryotic Genomic Sequences MIGS-Genome, metagenome or marker sequences (MIxS compliant)', 1),
('Cultured Bacterial/Archaeal Genomic Sequences MIGS-Genome, metagenome or marker sequences (MIxS compliant)', 1),
('Environmental/Metagenome Genomic Sequences MIMS -Genome, metagenome or marker sequences (MIxS compliant)', 1),
('Human sample', 1),
('Invertebrate', 1),
('Metagenome or environmental sample', 1),
('Microbe', 1),
('Model organism or animal sample', 1),
('Pathogen affecting public health', 1),
('Plant sample', 1),
('Specimen Marker Sequences MIMARKS-Genome, metagenome or marker sequences (MIxS compliant)', 1),
('Survey-related Marker Sequences MIMARKS-Genome, metagenome or marker sequences (MIxS compliant)', 1),
('Viral Genomic Sequences MIGS-Genome, metagenome or marker sequences (MIxS compliant)', 1),
('Virus sample', 1);

-- --------------------------------------------------------

--
-- Table structure for table `records`
--

CREATE TABLE `records` (
  `records` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `records`
--

INSERT INTO `records` (`records`, `visible`) VALUES
('Rotronics CO2 Meter 1', 1),
('Velocicalc unit1', 1);

-- --------------------------------------------------------

--
-- Table structure for table `relt_location`
--

CREATE TABLE `relt_location` (
  `loc_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `relt_location`
--

INSERT INTO `relt_location` (`loc_name`, `visible`) VALUES
('(pooled)', 1),
('10 M Below Surface', 1),
('30 M Below Surface', 1),
('50 cm from ceiling', 1),
('Bookshelf', 1),
('Desk', 1),
('Dock', 1),
('Floor', 1),
('Qubit', 1),
('Surf', 1),
('Surface Water', 1);

-- --------------------------------------------------------

--
-- Table structure for table `rna_extraction`
--

CREATE TABLE `rna_extraction` (
  `r_kit_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `rna_extraction`
--

INSERT INTO `rna_extraction` (`r_kit_name`, `visible`) VALUES
('QIAGEN-RNeasy Mini Kit', 0),
('RNA PowerSoil Total RNA Isolation Kit Sample', 0);

-- --------------------------------------------------------

--
-- Table structure for table `sample`
--

CREATE TABLE `sample` (
  `sample_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `sample_num` int(3) NOT NULL,
  `sample_sort` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `analysis_name` varchar(200) COLLATE utf8_unicode_ci DEFAULT NULL,
  `barcode` varchar(30) COLLATE utf8_unicode_ci DEFAULT NULL,
  `collector_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `d_conc` decimal(10,2) DEFAULT NULL,
  `d_conc_instrument` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `d_extraction_date` date DEFAULT NULL,
  `dExtrName` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `d_volume` float DEFAULT NULL,
  `d_volume_quant` float DEFAULT NULL,
  `dna_extract_kit_name` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `daily_data` date DEFAULT NULL,
  `end_samp_date_time` datetime DEFAULT NULL,
  `entered_by` varchar(30) COLLATE utf8_unicode_ci NOT NULL,
  `location_name` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `media_type` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `notes` mediumtext COLLATE utf8_unicode_ci,
  `orig_time_stamp` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `part_of_pool` varchar(1) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'N',
  `pool_extracts_id` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `pooled_flag` varchar(2) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'NP',
  `project_name` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `r_conc` decimal(10,2) DEFAULT NULL,
  `r_conc_instrument` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `r_extraction_date` date DEFAULT NULL,
  `rExtrName` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `r_volume` float DEFAULT NULL,
  `r_volume_quant` float DEFAULT NULL,
  `rna_extract_kit_name` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `relt_loc_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `sample_type` varchar(3) COLLATE utf8_unicode_ci DEFAULT NULL,
  `seq_id` varchar(8) COLLATE utf8_unicode_ci NOT NULL,
  `sequencing_info` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `start_samp_date_time` datetime DEFAULT NULL,
  `time_stamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `total_samp_time` float(10,4) DEFAULT NULL,
  `updated_by` varchar(30) COLLATE utf8_unicode_ci DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `sample`
--

INSERT INTO `sample` (`sample_name`, `sample_num`, `sample_sort`, `analysis_name`, `barcode`, `collector_name`, `d_conc`, `d_conc_instrument`, `d_extraction_date`, `dExtrName`, `d_volume`, `d_volume_quant`, `dna_extract_kit_name`, `daily_data`, `end_samp_date_time`, `entered_by`, `location_name`, `media_type`, `notes`, `orig_time_stamp`, `part_of_pool`, `pool_extracts_id`, `pooled_flag`, `project_name`, `r_conc`, `r_conc_instrument`, `r_extraction_date`, `rExtrName`, `r_volume`, `r_volume_quant`, `rna_extract_kit_name`, `relt_loc_name`, `sample_type`, `seq_id`, `sequencing_info`, `start_samp_date_time`, `time_stamp`, `total_samp_time`, `updated_by`) VALUES
('2016/05/23first-projectA001', 1, 'first-project001', NULL, NULL, 'Alice', '10.00', 'PicoGreen', '2016-05-27', 'Alice', 60, 20, 'MoBio Power Water Kit', NULL, '2016-05-23 05:00:00', 'Admin', 'Office', 'Eswab', NULL, '2016-05-23 03:41:27', 'N', NULL, 'NP', 'first-project', NULL, NULL, NULL, '', NULL, NULL, NULL, 'Bookshelf', 'A', 'FSTPJ001', NULL, '2016-05-23 03:00:00', '2016-10-16 23:12:52', 2.0000, 'Admin'),
('2016/05/23first-projectB004', 4, 'first-project004', NULL, NULL, 'Alice', '30.00', 'PicoGreen', '2016-05-27', 'Alice', 60, 20, 'MoBio Power Water Kit', NULL, '2016-05-23 07:00:00', 'Admin', 'Office', 'Eswab', NULL, '2016-05-23 03:45:48', 'N', NULL, 'NP', 'first-project', NULL, NULL, NULL, '', NULL, NULL, NULL, 'Bookshelf', 'B', 'FSTPJ004', '', '2016-05-23 07:00:00', '2016-05-23 03:54:29', 0.0000, 'Admin'),
('2016/05/24first-projectA002', 2, 'first-project002', NULL, NULL, 'Alice', '20.00', 'PicoGreen', '2016-05-27', 'Alice', 60, 20, 'MoBio Power Water Kit', NULL, '2016-05-24 18:00:00', 'Admin', 'Office', 'Eswab', NULL, '2016-05-23 03:45:16', 'N', NULL, 'NP', 'first-project', NULL, NULL, NULL, '', NULL, NULL, NULL, 'Bookshelf', 'A', 'FSTPJ002', '', '2016-05-24 07:00:00', '2016-05-23 04:19:32', 11.0000, 'Admin'),
('2016/05/24first-projectB003', 3, 'first-project003', NULL, NULL, 'Alice', '15.00', 'PicoGreen', '2016-05-27', 'Alice', 60, 20, 'MoBio Power Water Kit', NULL, '2016-05-24 07:00:00', 'Admin', 'Office', 'Eswab', '', '2016-05-23 03:45:38', 'N', NULL, 'NP', 'first-project', NULL, NULL, NULL, '', NULL, NULL, NULL, 'Bookshelf', 'B', 'FSTPJ003', '', '2016-05-24 07:00:00', '2016-05-23 03:45:38', 0.0000, NULL),
('2016/06/21second-projectB002', 2, 'second-project002', NULL, NULL, 'Dan', NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, '2016-06-21 07:00:00', 'Admin', 'Beach', 'N/A', '', '2016-05-23 03:47:54', 'N', NULL, 'NP', 'second-project', NULL, NULL, NULL, '', NULL, NULL, NULL, 'Surface Water', 'B', 'SCNPJ002', '', '2016-06-21 07:00:00', '2016-05-23 03:47:54', 0.0000, NULL),
('2016/06/21second-projectB004', 4, 'second-project004', NULL, NULL, 'Dan', NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, '2016-06-21 07:00:00', 'Admin', 'Beach', 'N/A', '', '2016-05-23 03:48:58', 'N', NULL, 'NP', 'second-project', NULL, NULL, NULL, '', NULL, NULL, NULL, '10 M Below Surface', 'B', 'SCNPJ004', '', '2016-06-21 07:00:00', '2016-05-23 03:48:58', 0.0000, NULL),
('2016/06/21second-projectB006', 6, 'second-project006', NULL, NULL, 'Dan', NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, '2016-06-21 07:00:00', 'Admin', 'Beach', 'N/A', '', '2016-05-23 03:49:45', 'N', NULL, 'NP', 'second-project', NULL, NULL, NULL, '', NULL, NULL, NULL, '30 M Below Surface', 'B', 'SCNPJ006', '', '2016-06-21 07:00:00', '2016-05-23 03:49:45', 0.0000, NULL),
('2016/06/21second-projectW001', 1, 'second-project001', NULL, NULL, 'Dan', NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, '2016-06-21 07:05:00', 'Admin', 'Beach', 'N/A', NULL, '2016-05-23 03:47:32', 'N', NULL, 'NP', 'second-project', NULL, NULL, NULL, '', NULL, NULL, NULL, 'Surface Water', 'W', 'SCNPJ001', NULL, '2016-06-21 07:00:00', '2016-11-06 10:58:43', 0.0800, 'Admin '),
('2016/06/21second-projectW003', 3, 'second-project003', NULL, NULL, 'Dan', NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, '2016-06-21 07:05:00', 'Admin', 'Beach', 'N/A', NULL, '2016-05-23 03:48:29', 'N', NULL, 'NP', 'second-project', NULL, NULL, NULL, '', NULL, NULL, NULL, '10 M Below Surface', 'W', 'SCNPJ003', NULL, '2016-06-21 07:00:00', '2016-11-06 11:22:57', 0.0800, 'Admin '),
('2016/06/21second-projectW005', 5, 'second-project005', NULL, NULL, 'Dan', NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, '2016-06-21 07:05:00', 'Admin', 'Beach', 'N/A', NULL, '2016-05-23 03:49:36', 'N', NULL, 'NP', 'second-project', NULL, NULL, NULL, '', NULL, NULL, NULL, '30 M Below Surface', 'W', 'SCNPJ005', NULL, '2016-06-21 07:00:00', '2016-11-06 11:24:00', 0.0800, 'Admin '),
('2016/09/01first-projectS005', 5, 'first-project005', NULL, NULL, 'Sue', NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, '2016-09-02 07:00:00', 'Admin', 'Beach', 'Eswab', NULL, '2016-09-19 08:04:32', 'N', NULL, 'NP', 'first-project', NULL, NULL, NULL, '', NULL, NULL, NULL, '10 M Below Surface', 'S', 'FSTPJ005', NULL, '2016-09-01 03:00:00', '2016-09-19 10:18:09', 28.0000, 'Admin');

-- --------------------------------------------------------

--
-- Table structure for table `sampler`
--

CREATE TABLE `sampler` (
  `sampler_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `serial_num` varchar(200) COLLATE utf8_unicode_ci DEFAULT NULL,
  `sampler_identifier` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `sampler`
--

INSERT INTO `sampler` (`sampler_name`, `serial_num`, `sampler_identifier`, `visible`) VALUES
('(pooled)', NULL, '', 1),
('Andersen Single Stage ImpactorN6', 'ABC568166611145', 'N6', 1),
('Bucket1', 'N/A', '1', 1),
('Pump1', 'N/A', '1', 1),
('Rosette1', 'X783450427668', '1', 1),
('Vaccum Pump1', 'B-476355846493', '1', 1);

-- --------------------------------------------------------

--
-- Table structure for table `sample_sampler`
--

CREATE TABLE `sample_sampler` (
  `sample_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `sampler_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `start_date_time` datetime NOT NULL,
  `end_date_time` datetime NOT NULL,
  `total_date_time` float NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `sample_sampler`
--

INSERT INTO `sample_sampler` (`sample_name`, `sampler_name`, `start_date_time`, `end_date_time`, `total_date_time`) VALUES
('2016/05/23first-projectA001', 'Vaccum Pump1', '2016-05-23 03:00:00', '2016-05-23 05:00:00', 2),
('2016/05/23first-projectB004', 'Vaccum Pump1', '2016-05-23 07:00:00', '2016-05-23 07:00:00', 0),
('2016/05/24first-projectA002', 'Vaccum Pump1', '2016-05-24 07:00:00', '2016-05-24 18:00:00', 11),
('2016/05/24first-projectB003', 'Vaccum Pump1', '2016-05-24 07:00:00', '2016-05-24 07:00:00', 0),
('2016/06/21second-projectB002', 'Rosette1', '2016-06-21 07:00:00', '2016-06-21 07:00:00', 0),
('2016/06/21second-projectB004', 'Rosette1', '2016-06-21 07:00:00', '2016-06-21 07:00:00', 0),
('2016/06/21second-projectB006', 'Rosette1', '2016-06-21 07:00:00', '2016-06-21 07:00:00', 0),
('2016/06/21second-projectW001', 'Rosette1', '2016-06-21 07:00:00', '2016-06-21 07:05:00', 0.08),
('2016/06/21second-projectW003', 'Rosette1', '2016-06-21 07:00:00', '2016-06-21 07:05:00', 0.08),
('2016/06/21second-projectW005', 'Rosette1', '2016-06-21 07:00:00', '2016-06-21 07:05:00', 0.08),
('2016/09/01first-projectS005', 'Andersen Single Stage ImpactorN6', '2016-09-01 03:00:00', '2016-09-01 08:10:00', 5.17),
('2016/09/01first-projectS005', 'Bucket1', '2016-09-01 03:00:00', '2016-09-01 08:10:00', 5.17),
('2016/09/01first-projectS005', 'Pump1', '2016-09-02 03:00:00', '2016-09-02 07:00:00', 4),
('2016/09/01first-projectS005', 'Vaccum Pump1', '2016-09-01 03:00:00', '2016-09-01 08:10:00', 5.17);

-- --------------------------------------------------------

--
-- Table structure for table `sample_sequencing2`
--

CREATE TABLE `sample_sequencing2` (
  `sample_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `seq_id` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `seq_sub_name` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `dna_conc` decimal(6,3) DEFAULT NULL,
  `vol` decimal(5,2) DEFAULT NULL,
  `wellLoc` varchar(5) COLLATE utf8_unicode_ci DEFAULT NULL,
  `sampBuffer` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `nano` decimal(6,3) DEFAULT NULL,
  `a_280` decimal(6,3) DEFAULT NULL,
  `a_230` decimal(6,3) DEFAULT NULL,
  `dnaCont` int(3) DEFAULT NULL,
  `RIN` decimal(3,1) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `sample_sequencing2`
--

INSERT INTO `sample_sequencing2` (`sample_name`, `seq_id`, `seq_sub_name`, `dna_conc`, `vol`, `wellLoc`, `sampBuffer`, `nano`, `a_280`, `a_230`, `dnaCont`, `RIN`) VALUES
('2016/05/23first-projectA001', '2016-05-23_49cc2_submission', 'FSTPJ001-M-02', '10.000', '100.00', '', 'Tris', NULL, NULL, NULL, NULL, NULL),
('2016/05/23first-projectA001', '2016-05-23_f9f27_submission', 'FSTPJ001-M-01', '10.000', '100.00', '', 'Tris', NULL, NULL, NULL, NULL, NULL),
('2016/05/23first-projectB004', '2016-05-23_49cc2_submission', 'FSTPJ004-M-02', '85.000', '100.00', '', 'Tris', NULL, NULL, NULL, NULL, NULL),
('2016/05/23first-projectB004', '2016-05-23_f9f27_submission', 'FSTPJ004-M-01', '85.000', '100.00', '', 'Tris', NULL, NULL, NULL, NULL, NULL),
('2016/05/24first-projectA002', '2016-05-23_49cc2_submission', 'FSTPJ002-M-02', '50.000', '100.00', '', 'Tris', NULL, NULL, NULL, NULL, NULL),
('2016/05/24first-projectA002', '2016-05-23_f9f27_submission', 'FSTPJ002-M-01', '50.000', '100.00', '', 'Tris', NULL, NULL, NULL, NULL, NULL),
('2016/05/24first-projectB003', '2016-05-23_49cc2_submission', 'FSTPJ003-M-02', '80.000', '100.00', '', 'Tris', NULL, NULL, NULL, NULL, NULL),
('2016/05/24first-projectB003', '2016-05-23_f9f27_submission', 'FSTPJ003-M-01', '80.000', '100.00', '', 'Tris', NULL, NULL, NULL, NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `sample_type`
--

CREATE TABLE `sample_type` (
  `sample_type_id` varchar(3) COLLATE utf8_unicode_ci NOT NULL,
  `sample_type_name` varchar(30) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `sample_type`
--

INSERT INTO `sample_type` (`sample_type_id`, `sample_type_name`, `visible`) VALUES
('A', 'Air', 1),
('B', 'Blank-Sterilization', 1),
('P', 'Pooled', 1),
('S', 'Soil', 1),
('W', 'Water', 1);

-- --------------------------------------------------------

--
-- Table structure for table `sequencing2`
--

CREATE TABLE `sequencing2` (
  `sequencing_info` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `container_type` varchar(15) COLLATE utf8_unicode_ci DEFAULT NULL,
  `date_submitted` date DEFAULT NULL,
  `dna_conc_of_subm` decimal(5,2) DEFAULT NULL,
  `entered_by` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `library_prep_kit` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `sample_type` varchar(20) COLLATE utf8_unicode_ci DEFAULT NULL,
  `seqOther` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `sequencer_name` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `sequencing_method` varchar(20) COLLATE utf8_unicode_ci DEFAULT NULL,
  `sequencing_type` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `submitted_by` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `primerL` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `primerR` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `quant_method` varchar(10) COLLATE utf8_unicode_ci DEFAULT NULL,
  `read_length` varchar(20) COLLATE utf8_unicode_ci DEFAULT NULL,
  `volume_of_aliquot` float DEFAULT NULL,
  `seq_pool` varchar(3) COLLATE utf8_unicode_ci DEFAULT NULL,
  `amplicon_type` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `results_recieved` date DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `sequencing2`
--

INSERT INTO `sequencing2` (`sequencing_info`, `container_type`, `date_submitted`, `dna_conc_of_subm`, `entered_by`, `library_prep_kit`, `sample_type`, `seqOther`, `sequencer_name`, `sequencing_method`, `sequencing_type`, `submitted_by`, `primerL`, `primerR`, `quant_method`, `read_length`, `volume_of_aliquot`, `seq_pool`, `amplicon_type`, `results_recieved`) VALUES
('2016-05-23_49cc2_submission', 'Tube', '2016-05-23', NULL, 'admin', 'Low Input Library Prep Kit', 'Genomic DNA', NULL, NULL, 'Indexed Paired End', 'Metagenome sequencing', 'admin@metalims.com', NULL, NULL, NULL, '100bp (HiSeq)', NULL, 'Yes', NULL, NULL),
('2016-05-23_f9f27_submission', 'Tube', '2016-05-23', NULL, 'admin', 'Low Input Library Prep Kit', 'Genomic DNA', NULL, NULL, 'Indexed Paired End', 'Metagenome sequencing', 'admin@metalims.com', NULL, NULL, NULL, '100bp (HiSeq)', NULL, 'Yes', NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `sequencing_method`
--

CREATE TABLE `sequencing_method` (
  `method` varchar(20) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `sequencing_method`
--

INSERT INTO `sequencing_method` (`method`, `visible`) VALUES
('Indexed Paired End', 1),
('Indexed Single Read', 1),
('Paired End', 1),
('Single Read', 1);

-- --------------------------------------------------------

--
-- Table structure for table `storage_info`
--

CREATE TABLE `storage_info` (
  `sample_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `original` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `remaining` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `orig_sample_exists` varchar(5) COLLATE utf8_unicode_ci NOT NULL,
  `dna_extr` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `DNA_sample_exists` varchar(5) COLLATE utf8_unicode_ci DEFAULT 'two',
  `rna_extr` varchar(150) COLLATE utf8_unicode_ci DEFAULT NULL,
  `RNA_sample_exists` varchar(5) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'two',
  `time_stamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `storage_info`
--

INSERT INTO `storage_info` (`sample_name`, `original`, `remaining`, `orig_sample_exists`, `dna_extr`, `DNA_sample_exists`, `rna_extr`, `RNA_sample_exists`, `time_stamp`) VALUES
('2016/05/23first-projectA001', '20C,Alice', NULL, 'true', '20C,Alice', 'one', '0,0', 'two', '2016-09-19 06:29:26'),
('2016/05/23first-projectB004', '20C,Alice', NULL, 'true', '-80C,F1', 'one', '0,0', 'two', '2016-05-23 03:45:48'),
('2016/05/24first-projectA002', '20C,Alice', NULL, 'true', '-80C,F1', 'one', '0,0', 'two', '2016-05-23 03:45:16'),
('2016/05/24first-projectB003', '20C,Alice', NULL, 'true', '-80C,F1', 'one', '0,0', 'two', '2016-05-23 03:45:38'),
('2016/06/21second-projectB002', '-80C,F1', NULL, 'true', '0,0', 'two', '0,0', 'two', '2016-05-23 03:47:54'),
('2016/06/21second-projectB004', '-80C,F1', NULL, 'true', '0,0', 'two', '0,0', 'two', '2016-05-23 03:48:58'),
('2016/06/21second-projectB006', '-80C,F1', NULL, 'true', '0,0', 'two', '0,0', 'two', '2016-05-23 03:49:45'),
('2016/06/21second-projectW001', '-80C,F1', NULL, 'true', '0,0', 'two', '0,0', 'two', '2016-05-23 03:47:32'),
('2016/06/21second-projectW003', '-80C,F1', NULL, 'true', '0,0', 'two', '0,0', 'two', '2016-05-23 03:48:29'),
('2016/06/21second-projectW005', '-80C,F1', NULL, 'true', '0,0', 'two', '0,0', 'two', '2016-05-23 03:49:36'),
('2016/09/01first-projectS005', '-80C,F1', NULL, 'true', '0,0', 'two', '0,0', 'two', '2016-09-18 17:04:32');

-- --------------------------------------------------------

--
-- Table structure for table `thing_storing`
--

CREATE TABLE `thing_storing` (
  `sample_name` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `thing_id` int(11) NOT NULL,
  `thing_value` varchar(300) COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `thing_storing`
--

INSERT INTO `thing_storing` (`sample_name`, `thing_id`, `thing_value`) VALUES
('2016/06/21second-projectW001', 1, '25'),
('2016/06/21second-projectW001', 2, '30'),
('2016/06/21second-projectW001', 3, '100'),
('2016/06/21second-projectW003', 1, '25'),
('2016/06/21second-projectW003', 2, '30'),
('2016/06/21second-projectW003', 3, '75'),
('2016/06/21second-projectW005', 1, '25'),
('2016/06/21second-projectW005', 2, '32'),
('2016/06/21second-projectW005', 3, '80');

-- --------------------------------------------------------

--
-- Table structure for table `type_seq_sample`
--

CREATE TABLE `type_seq_sample` (
  `sample_type` varchar(20) COLLATE utf8_unicode_ci NOT NULL,
  `visible` tinyint(1) DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `type_seq_sample`
--

INSERT INTO `type_seq_sample` (`sample_type`, `visible`) VALUES
('Amplicon', 1),
('cDNA', 1),
('Genomic DNA', 1),
('Library', 1),
('Purified mRNA', 1),
('Purified small RNA', 1),
('Single-stranded DNA', 1),
('Total RNA', 1);

-- --------------------------------------------------------

--
-- Table structure for table `users`
--

CREATE TABLE `users` (
  `user_id` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `first_name` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `last_name` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `password` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `session_id` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `time` float NOT NULL,
  `status` varchar(7) COLLATE utf8_unicode_ci NOT NULL,
  `pkey` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `visible` varchar(1) COLLATE utf8_unicode_ci DEFAULT '1',
  `admin` varchar(1) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'N',
  `first_failed_login` int(11) DEFAULT '0',
  `failed_login_count` int(11) DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `users`
--

INSERT INTO `users` (`user_id`, `first_name`, `last_name`, `password`, `session_id`, `time`, `status`, `pkey`, `visible`, `admin`, `first_failed_login`, `failed_login_count`) VALUES
('admin@metalims.com', 'Admin', '', '$2y$10$YSaGTh/gr018WJe70o1E6.LmIAgOKqJIywwFgE5TEwmk4jfSAuB46', '9abe2lpsqch2fkg160ap244pv0', 1477730000, 'done', '9d63f2f4ace1f815753a6f748e2dc0a60c5cfabbe76520f5eb6eef7d5a49fd9d', '1', 'Y', 1478404793, 1),
('newuser@metalims.com', 'New', 'User', '$2y$10$s20PL5Q6mAlrl5TNj1wRcOCWBlf14JwKoOy8o7QjCC09ZTIMory4O', '6qq48or4k3jv459v6eaoo88gn4', 0, '', '', '1', 'N', 0, 0);

--
-- Indexes for dumped tables
--

--
-- Indexes for table `analysis`
--
ALTER TABLE `analysis`
  ADD PRIMARY KEY (`analysis_name`);

--
-- Indexes for table `application`
--
ALTER TABLE `application`
  ADD PRIMARY KEY (`application`);

--
-- Indexes for table `container_type`
--
ALTER TABLE `container_type`
  ADD PRIMARY KEY (`container_type`);

--
-- Indexes for table `create_user_things`
--
ALTER TABLE `create_user_things`
  ADD PRIMARY KEY (`thing_id`);

--
-- Indexes for table `daily_data2`
--
ALTER TABLE `daily_data2`
  ADD PRIMARY KEY (`daily_date`,`location`),
  ADD KEY `location` (`location`);

--
-- Indexes for table `daily_data2_particle_counter`
--
ALTER TABLE `daily_data2_particle_counter`
  ADD PRIMARY KEY (`daily_date`,`location`,`part_sens_name`),
  ADD KEY `part_sens_name` (`part_sens_name`),
  ADD KEY `location` (`location`),
  ADD KEY `record_source` (`record_source`);

--
-- Indexes for table `dna_extraction`
--
ALTER TABLE `dna_extraction`
  ADD PRIMARY KEY (`d_kit_name`);

--
-- Indexes for table `drawer`
--
ALTER TABLE `drawer`
  ADD PRIMARY KEY (`drawer_id`);

--
-- Indexes for table `freezer`
--
ALTER TABLE `freezer`
  ADD PRIMARY KEY (`freezer_id`);

--
-- Indexes for table `freezer_drawer`
--
ALTER TABLE `freezer_drawer`
  ADD PRIMARY KEY (`freezer_id`,`drawer_id`),
  ADD KEY `drawer_id` (`drawer_id`);

--
-- Indexes for table `library_prep_kit`
--
ALTER TABLE `library_prep_kit`
  ADD PRIMARY KEY (`lib_prep_kit`);

--
-- Indexes for table `location`
--
ALTER TABLE `location`
  ADD PRIMARY KEY (`loc_name`);

--
-- Indexes for table `media_type`
--
ALTER TABLE `media_type`
  ADD PRIMARY KEY (`media_type`);

--
-- Indexes for table `number_of_seq_submissions`
--
ALTER TABLE `number_of_seq_submissions`
  ADD PRIMARY KEY (`sample_name`);

--
-- Indexes for table `particle_counter`
--
ALTER TABLE `particle_counter`
  ADD PRIMARY KEY (`part_sens_name`);

--
-- Indexes for table `pooled_sample_lookup`
--
ALTER TABLE `pooled_sample_lookup`
  ADD PRIMARY KEY (`new_pooled_samp_name`,`orig_sample_name`),
  ADD KEY `orig_sample_name` (`orig_sample_name`);

--
-- Indexes for table `project_name`
--
ALTER TABLE `project_name`
  ADD PRIMARY KEY (`project_name`);

--
-- Indexes for table `quantitation_method`
--
ALTER TABLE `quantitation_method`
  ADD PRIMARY KEY (`quant_method`);

--
-- Indexes for table `quant_instruments`
--
ALTER TABLE `quant_instruments`
  ADD PRIMARY KEY (`kit_name`);

--
-- Indexes for table `read_length`
--
ALTER TABLE `read_length`
  ADD PRIMARY KEY (`read_length`);

--
-- Indexes for table `read_submission`
--
ALTER TABLE `read_submission`
  ADD PRIMARY KEY (`sample_name`,`subm_id`),
  ADD KEY `subm_db` (`subm_db`),
  ADD KEY `type_exp` (`type_exp`);

--
-- Indexes for table `read_subm_database`
--
ALTER TABLE `read_subm_database`
  ADD PRIMARY KEY (`database_name`);

--
-- Indexes for table `read_subm_exp_types`
--
ALTER TABLE `read_subm_exp_types`
  ADD PRIMARY KEY (`exp_types`);

--
-- Indexes for table `records`
--
ALTER TABLE `records`
  ADD PRIMARY KEY (`records`);

--
-- Indexes for table `relt_location`
--
ALTER TABLE `relt_location`
  ADD PRIMARY KEY (`loc_name`);

--
-- Indexes for table `rna_extraction`
--
ALTER TABLE `rna_extraction`
  ADD PRIMARY KEY (`r_kit_name`);

--
-- Indexes for table `sample`
--
ALTER TABLE `sample`
  ADD PRIMARY KEY (`sample_name`),
  ADD KEY `analysis_name` (`analysis_name`),
  ADD KEY `media_type` (`media_type`),
  ADD KEY `location_name` (`location_name`),
  ADD KEY `relt_loc_name` (`relt_loc_name`),
  ADD KEY `project_name` (`project_name`),
  ADD KEY `sample_type` (`sample_type`),
  ADD KEY `dna_extract_kit_name` (`dna_extract_kit_name`),
  ADD KEY `d_conc_instrument` (`d_conc_instrument`),
  ADD KEY `r_conc_instrument` (`r_conc_instrument`),
  ADD KEY `rna_extract_kit_name` (`rna_extract_kit_name`);

--
-- Indexes for table `sampler`
--
ALTER TABLE `sampler`
  ADD PRIMARY KEY (`sampler_name`);

--
-- Indexes for table `sample_sampler`
--
ALTER TABLE `sample_sampler`
  ADD PRIMARY KEY (`sample_name`,`sampler_name`),
  ADD KEY `sampler_name` (`sampler_name`);

--
-- Indexes for table `sample_sequencing2`
--
ALTER TABLE `sample_sequencing2`
  ADD PRIMARY KEY (`sample_name`,`seq_id`),
  ADD KEY `seq_id` (`seq_id`);

--
-- Indexes for table `sample_type`
--
ALTER TABLE `sample_type`
  ADD PRIMARY KEY (`sample_type_id`);

--
-- Indexes for table `sequencing2`
--
ALTER TABLE `sequencing2`
  ADD PRIMARY KEY (`sequencing_info`),
  ADD KEY `container_type` (`container_type`),
  ADD KEY `library_prep_kit` (`library_prep_kit`),
  ADD KEY `sample_type` (`sample_type`),
  ADD KEY `sequencing_method` (`sequencing_method`),
  ADD KEY `quant_method` (`quant_method`),
  ADD KEY `read_length` (`read_length`),
  ADD KEY `sequencing_type` (`sequencing_type`);

--
-- Indexes for table `sequencing_method`
--
ALTER TABLE `sequencing_method`
  ADD PRIMARY KEY (`method`);

--
-- Indexes for table `storage_info`
--
ALTER TABLE `storage_info`
  ADD PRIMARY KEY (`sample_name`);

--
-- Indexes for table `thing_storing`
--
ALTER TABLE `thing_storing`
  ADD PRIMARY KEY (`sample_name`,`thing_id`),
  ADD KEY `thing_id` (`thing_id`);

--
-- Indexes for table `type_seq_sample`
--
ALTER TABLE `type_seq_sample`
  ADD PRIMARY KEY (`sample_type`);

--
-- Indexes for table `users`
--
ALTER TABLE `users`
  ADD PRIMARY KEY (`user_id`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `create_user_things`
--
ALTER TABLE `create_user_things`
  MODIFY `thing_id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=4;
--
-- Constraints for dumped tables
--

--
-- Constraints for table `daily_data2`
--
ALTER TABLE `daily_data2`
  ADD CONSTRAINT `daily_data2_ibfk_1` FOREIGN KEY (`location`) REFERENCES `location` (`loc_name`) ON UPDATE CASCADE;

--
-- Constraints for table `daily_data2_particle_counter`
--
ALTER TABLE `daily_data2_particle_counter`
  ADD CONSTRAINT `daily_data2_particle_counter_ibfk_1` FOREIGN KEY (`part_sens_name`) REFERENCES `particle_counter` (`part_sens_name`) ON UPDATE CASCADE,
  ADD CONSTRAINT `daily_data2_particle_counter_ibfk_2` FOREIGN KEY (`location`) REFERENCES `location` (`loc_name`) ON UPDATE CASCADE,
  ADD CONSTRAINT `daily_data2_particle_counter_ibfk_3` FOREIGN KEY (`record_source`) REFERENCES `records` (`records`) ON UPDATE CASCADE;

--
-- Constraints for table `freezer_drawer`
--
ALTER TABLE `freezer_drawer`
  ADD CONSTRAINT `freezer_drawer_ibfk_1` FOREIGN KEY (`freezer_id`) REFERENCES `freezer` (`freezer_id`) ON UPDATE CASCADE,
  ADD CONSTRAINT `freezer_drawer_ibfk_2` FOREIGN KEY (`drawer_id`) REFERENCES `drawer` (`drawer_id`) ON UPDATE CASCADE;

--
-- Constraints for table `number_of_seq_submissions`
--
ALTER TABLE `number_of_seq_submissions`
  ADD CONSTRAINT `number_of_seq_submissions_ibfk_1` FOREIGN KEY (`sample_name`) REFERENCES `sample` (`sample_name`) ON UPDATE CASCADE;

--
-- Constraints for table `pooled_sample_lookup`
--
ALTER TABLE `pooled_sample_lookup`
  ADD CONSTRAINT `pooled_sample_lookup_ibfk_1` FOREIGN KEY (`new_pooled_samp_name`) REFERENCES `sample` (`sample_name`) ON UPDATE CASCADE,
  ADD CONSTRAINT `pooled_sample_lookup_ibfk_2` FOREIGN KEY (`orig_sample_name`) REFERENCES `sample` (`sample_name`) ON UPDATE CASCADE;

--
-- Constraints for table `read_submission`
--
ALTER TABLE `read_submission`
  ADD CONSTRAINT `read_submission_ibfk_1` FOREIGN KEY (`subm_db`) REFERENCES `read_subm_database` (`database_name`) ON UPDATE CASCADE,
  ADD CONSTRAINT `read_submission_ibfk_2` FOREIGN KEY (`type_exp`) REFERENCES `read_subm_exp_types` (`exp_types`) ON UPDATE CASCADE,
  ADD CONSTRAINT `read_submission_ibfk_3` FOREIGN KEY (`sample_name`) REFERENCES `sample` (`sample_name`) ON UPDATE CASCADE;

--
-- Constraints for table `sample`
--
ALTER TABLE `sample`
  ADD CONSTRAINT `sample_ibfk_1` FOREIGN KEY (`analysis_name`) REFERENCES `analysis` (`analysis_name`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sample_ibfk_10` FOREIGN KEY (`sample_type`) REFERENCES `sample_type` (`sample_type_id`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sample_ibfk_2` FOREIGN KEY (`d_conc_instrument`) REFERENCES `quant_instruments` (`kit_name`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sample_ibfk_3` FOREIGN KEY (`dna_extract_kit_name`) REFERENCES `dna_extraction` (`d_kit_name`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sample_ibfk_4` FOREIGN KEY (`location_name`) REFERENCES `location` (`loc_name`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sample_ibfk_5` FOREIGN KEY (`media_type`) REFERENCES `media_type` (`media_type`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sample_ibfk_6` FOREIGN KEY (`project_name`) REFERENCES `project_name` (`project_name`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sample_ibfk_7` FOREIGN KEY (`r_conc_instrument`) REFERENCES `quant_instruments` (`kit_name`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sample_ibfk_8` FOREIGN KEY (`rna_extract_kit_name`) REFERENCES `rna_extraction` (`r_kit_name`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sample_ibfk_9` FOREIGN KEY (`relt_loc_name`) REFERENCES `relt_location` (`loc_name`) ON UPDATE CASCADE;

--
-- Constraints for table `sample_sampler`
--
ALTER TABLE `sample_sampler`
  ADD CONSTRAINT `sample_sampler_ibfk_1` FOREIGN KEY (`sample_name`) REFERENCES `sample` (`sample_name`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sample_sampler_ibfk_2` FOREIGN KEY (`sampler_name`) REFERENCES `sampler` (`sampler_name`) ON UPDATE CASCADE;

--
-- Constraints for table `sample_sequencing2`
--
ALTER TABLE `sample_sequencing2`
  ADD CONSTRAINT `sample_sequencing2_ibfk_1` FOREIGN KEY (`sample_name`) REFERENCES `sample` (`sample_name`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sample_sequencing2_ibfk_2` FOREIGN KEY (`seq_id`) REFERENCES `sequencing2` (`sequencing_info`) ON UPDATE CASCADE;

--
-- Constraints for table `sequencing2`
--
ALTER TABLE `sequencing2`
  ADD CONSTRAINT `sequencing2_ibfk_1` FOREIGN KEY (`container_type`) REFERENCES `container_type` (`container_type`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sequencing2_ibfk_2` FOREIGN KEY (`library_prep_kit`) REFERENCES `library_prep_kit` (`lib_prep_kit`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sequencing2_ibfk_3` FOREIGN KEY (`sequencing_method`) REFERENCES `sequencing_method` (`method`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sequencing2_ibfk_4` FOREIGN KEY (`sequencing_type`) REFERENCES `application` (`application`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sequencing2_ibfk_5` FOREIGN KEY (`quant_method`) REFERENCES `quantitation_method` (`quant_method`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sequencing2_ibfk_6` FOREIGN KEY (`read_length`) REFERENCES `read_length` (`read_length`) ON UPDATE CASCADE,
  ADD CONSTRAINT `sequencing2_ibfk_7` FOREIGN KEY (`sample_type`) REFERENCES `type_seq_sample` (`sample_type`) ON UPDATE CASCADE;

--
-- Constraints for table `storage_info`
--
ALTER TABLE `storage_info`
  ADD CONSTRAINT `storage_info_ibfk_1` FOREIGN KEY (`sample_name`) REFERENCES `sample` (`sample_name`) ON UPDATE CASCADE;

--
-- Constraints for table `thing_storing`
--
ALTER TABLE `thing_storing`
  ADD CONSTRAINT `thing_storing_ibfk_1` FOREIGN KEY (`sample_name`) REFERENCES `sample` (`sample_name`) ON UPDATE CASCADE,
  ADD CONSTRAINT `thing_storing_ibfk_2` FOREIGN KEY (`thing_id`) REFERENCES `create_user_things` (`thing_id`) ON UPDATE CASCADE;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
